/*****************************************************
This program was produced by the
CodeWizardAVR V2.04.4a Advanced
Automatic Program Generator
 Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 11.04.2011
Author  : NeVaDa
Company : home
Comments: 


Chip type               : ATmega32
Program type            : Application
AVR Core Clock frequency: 16,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 512
*****************************************************/

#include <mega32.h>

#include <io.h>
#include <delay.h>

#include <stdlib.h>

#include <stdio.h>
#include <string.h>

#include "lcd.c"


// SPI functions
#include <spi.h>

#include <sdcard.h>
#include <ff.h>


unsigned char Buffer[256];

FRESULT res;
FATFS fat;
FIL file_1;

FATFS *pfat;

char *flash error_msg[] = 
{       
"",
"FR_DISK_ERR",
"FR_INT_ERR",
"FR_INT_ERR",
"FR_NOT_READY",
"FR_NO_FILE",
"FR_NO_PATH",
"FR_INVALID_NAME",
"FR_DENIED",
"FR_EXIST",
"FR_INVALID_OBJECT",
"FR_WRITE_PROTECTED",
"FR_INVALID_DRIVE",
"FR_NOT_ENABLED",
"FR_NO_FILESYSTEM",
"FR_MKFS_ABORTED",
"FR_TIMEOUT"
};                        


void error(FRESULT res)
{
        if ((res>=FR_DISK_ERR)&&(res<=FR_TIMEOUT))
        {
                lcd_str(error_msg[res]);
        }
}



//DIR directory;
unsigned int nbytes;



unsigned char path[10] = {"0:/1.txt"};











/*
==============================================================================================
           Timer 0
==============================================================================================
*/   

interrupt [TIM0_OVF] void timer0_ovf_isr (void)
{

TCNT0 = 0x06;

disk_timerproc();



}

interrupt [TIM1_OVF] void timer1_ovf_isr (void)
{

TCNT1H=0xFF;
TCNT1L=0x06;




}



// Declare your global variables here

void main(void)
{
// Declare your local variables here

unsigned char disk_status;        

char index;
char chr;
char stroka;

// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func7=In Func6=Out Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=0 State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0xFF;
DDRB=0b11111100;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0xFF;
DDRC=0xFF;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

//  Timer 0
//TCCR0=0x00;
TCCR0=0x03;
TCNT0=0x06;         

//  Timer 1
TCCR1B=0x05;
TCCR1A=0x00;
TCNT1H=0xFF;
TCNT1L=0x06;
OCR1BL=0x00;
OCR1BH=0x00;
OCR1AL=0x00;
OCR1AH=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
MCUCR=0x00;
MCUCSR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x05;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// spi
SPCR=0x50;
SPSR=0x01;


lcd_init(); 
lcd_contrast(0x5F);

lcd_clear();






#asm("sei");                          



//lcd_str("ok");


          disk_status = disk_initialize(0);   

          if (disk_status & STA_NOINIT)
          {
                lcd_str("Disk init failed!");                  
          }
          else
          {
                lcd_str("Init OK");
          } 
          if (disk_status & STA_NODISK)
          {
                 lcd_str("Cart not present!");
          }
          else
          {
                   lcd_str("Cart persent!");
          } 

          if (disk_status & STA_PROTECT)
          {

                lcd_str("Disk protected");
          }
          else
          {
                 lcd_str("NOT PROTRECT ...ok");
          } 




           if ((res = f_mount(0,&fat)) == FR_OK)
           {     

                        lcd_str("Drive 0: mounted");


                        
                       if ((res=f_open(&file_1,path,FA_READ)) == FR_OK)
                       {


                                  lcd_goto_xy(0,0);

                                   if ((res=f_read(&file_1,Buffer,sizeof(Buffer)-1,&nbytes)) == FR_OK)
                                   {                         
                                                  

                                          res = f_close(&file_1);




                                   }                          
                                   else
                                   {
                                          lcd_str("file read err");

                                          delay_ms(2000);
                                   }

                       }                          
                       else
                       {
                            lcd_str("file open err");

                            error(res);
                            delay_ms(2000);
                       }    


           }     
           else
           {
                      lcd_str("Error mounted");
                      
                      error(res);

                      delay_ms(2000);       
           }

           


while (1)
      {
      // Place your code here
      };
}
